diff -r Slicetype/common/common.h x264/common/common.h
27,28d26
< #define ENABLE_HACK_SLICETYPE 1 
< 
diff -r Slicetype/common/frame.c x264/common/frame.c
65d64
<    
80,86d78
<     
< #if ENABLE_HACK_SLICETYPE
<     CHECKED_MALLOC( frame->buffer_orgfilter, 4*luma_plane_size);
<     for( i = 0; i < 4; i++ ) {
<         frame->orgfiltered[i] = frame->buffer_orgfilter + i*luma_plane_size + frame->i_stride[0] * i_padv + PADH;
<     }
< #endif
127c119
<     CHECKED_MALLOC( frame->i_intra_cost, i_mb_count * sizeof(uint32_t) );
---
>     CHECKED_MALLOC( frame->i_intra_cost, i_mb_count * sizeof(uint16_t) );
178,180d169
< #if ENABLE_HACK_SLICETYPE
<     x264_free(frame->buffer_orgfilter);
< #endif
251c240
< void x264_frame_expand_border( x264_t *h, x264_frame_t *frame, int mb_y, int b_end, int b_org )
---
> void x264_frame_expand_border( x264_t *h, x264_frame_t *frame, int mb_y, int b_end )
255d243
<     int i_num_planes= b_org?1:frame->i_plane;
258c246
<     for( i = 0; i < i_num_planes; i++ )
---
>     for( i = 0; i < frame->i_plane; i++ )
266,267c254
<         uint8_t *pix = b_org ? frame->orgfiltered[i]:frame->plane[i];
<         pix += X264_MAX(0, (16*mb_y-4)*stride >> !!i);
---
>         uint8_t *pix = frame->plane[i] + X264_MAX(0, (16*mb_y-4)*stride >> !!i);
282c269
< void x264_frame_expand_border_filtered( x264_t *h, x264_frame_t *frame, int mb_y, int b_end, int b_org )
---
> void x264_frame_expand_border_filtered( x264_t *h, x264_frame_t *frame, int mb_y, int b_end )
297,298c284
<         uint8_t *pix = b_org? frame->orgfiltered[i] : frame->filtered[i];
<         pix += (16*mb_y - (8 << h->sh.b_mbaff)) * stride - 4;
---
>         uint8_t *pix = frame->filtered[i] + (16*mb_y - (8 << h->sh.b_mbaff)) * stride - 4;
diff -r Slicetype/common/frame.h x264/common/frame.h
61,63d60
<     
<     uint8_t *buffer_orgfilter;
<     uint8_t *orgfiltered[4];      // Used to store the orig, H, V, HV of origin frame
88c85
<     uint32_t *i_intra_cost;
---
>     uint16_t *i_intra_cost;
90d86
<    
119,120c115,116
< void          x264_frame_expand_border( x264_t *h, x264_frame_t *frame, int mb_y, int b_end, int b_org );
< void          x264_frame_expand_border_filtered( x264_t *h, x264_frame_t *frame, int mb_y, int b_end, int b_org );
---
> void          x264_frame_expand_border( x264_t *h, x264_frame_t *frame, int mb_y, int b_end );
> void          x264_frame_expand_border_filtered( x264_t *h, x264_frame_t *frame, int mb_y, int b_end );
127c123
< void          x264_frame_filter( x264_t *h, x264_frame_t *frame, int mb_y, int b_end, int b_org );
---
> void          x264_frame_filter( x264_t *h, x264_frame_t *frame, int mb_y, int b_end );

diff -r Slicetype/common/macroblock.c x264/common/macroblock.c
397,399d396
< #if ENABLE_HACK_SLICETYPE
<         if( lowres_mv[0][0] != 0x7fff ) *(uint32_t*)mvc[i++] = (*(uint32_t*)lowres_mv[h->mb.i_mb_xy])&0xfffeffff;
< #else
401d397
< #endif
diff -r Slicetype/common/mc.c x264/common/mc.c
404c404
< void x264_frame_filter( x264_t *h, x264_frame_t *frame, int mb_y, int b_end, int b_org )
---
> void x264_frame_filter( x264_t *h, x264_frame_t *frame, int mb_y, int b_end )
413,414d412
<     uint8_t *filtered[2][4] = {{frame->filtered[0], frame->filtered[1], frame->filtered[2], frame->filtered[3]}, 
<                                         {frame->orgfiltered[0], frame->orgfiltered[1], frame->orgfiltered[2], frame->orgfiltered[3]}};
422,425c420,423
<             filtered[b_org][1] + offs,
<             filtered[b_org][2] + offs,
<             filtered[b_org][3] + offs,
<             filtered[b_org][0] + offs,
---
>             frame->filtered[1] + offs,
>             frame->filtered[2] + offs,
>             frame->filtered[3] + offs,
>             frame->plane[0] + offs,

diff -r Slicetype/encoder/encoder.c x264/encoder/encoder.c
1015c1015
<         x264_frame_expand_border( h, h->fdec, min_y, b_end, 0 );
---
>         x264_frame_expand_border( h, h->fdec, min_y, b_end );
1018,1019c1018,1019
<             x264_frame_filter( h, h->fdec, min_y, b_end, 0 );
<             x264_frame_expand_border_filtered( h, h->fdec, min_y, b_end, 0 );
---
>             x264_frame_filter( h, h->fdec, min_y, b_end );
>             x264_frame_expand_border_filtered( h, h->fdec, min_y, b_end );
1078,1080d1077
< #if ENABLE_HACK_SLICETYPE
<         XCHG( uint8_t*, h->fdec->orgfiltered[i], h->fenc->orgfiltered[i] );
< #endif
1082,1085d1078
<     
< #if ENABLE_HACK_SLICETYPE
<     XCHG( uint8_t*, h->fdec->buffer_orgfilter, h->fenc->buffer_orgfilter );
< #endif
1416,1429d1408
<             
< #if ENABLE_HACK_SLICETYPE
<         {
<             /* Calculate Half-pel of origin image */
<             int i_mb_y;
<             memcpy(fenc->orgfiltered[0], fenc->plane[0], fenc->i_stride[0]*fenc->i_lines[0]);
<             for( i_mb_y = 0; i_mb_y < h->sps->i_mb_height; i_mb_y++ ) {
<                 int b_end = i_mb_y == h->sps->i_mb_height-1?1:0;
<                 x264_frame_expand_border(h, fenc, i_mb_y, b_end, 1);
<                 x264_frame_filter(h, fenc, i_mb_y, b_end, 1);
<                 x264_frame_expand_border_filtered(h, fenc, i_mb_y, b_end, 1);
<             }
<         }
< #endif
1435c1414
<         if( h->frames.b_have_lowres ) {
---
>         if( h->frames.b_have_lowres )
1437d1415
<         }
diff -r Slicetype/encoder/slicetype.c x264/encoder/slicetype.c
35,37d34
< #if ENABLE_HACK_SLICETYPE
<     a->i_qp = 24;
< #else
39d35
< #endif
47,242d42
< #if ENABLE_HACK_SLICETYPE
< static int x264_slicetype_mb_cost( x264_t *h, x264_mb_analysis_t *a,
<                             x264_frame_t **frames, int p0, int p1, int b,
<                             int dist_scale_factor, int do_search[2] )
< {
<     x264_frame_t *fref0 = frames[p0];
<     x264_frame_t *fref1 = frames[p1];
<     x264_frame_t *fenc  = frames[b];
<     const int b_bidir = (b < p1);
<     const int i_mb_x = h->mb.i_mb_x;
<     const int i_mb_y = h->mb.i_mb_y;
<     const int i_mb_stride = h->sps->i_mb_width;
<     const int i_mb_xy = i_mb_x + i_mb_y * i_mb_stride;
<     const int i_stride = fenc->i_stride[0];
<     const int i_pel_offset = 16 * ( i_mb_x + i_mb_y * i_stride );
<     const int i_bipred_weight = h->param.analyse.b_weighted_bipred ? 64 - (dist_scale_factor>>2) : 32;
<     int16_t (*fenc_mvs[2])[2] = { &frames[b]->lowres_mvs[0][b-p0-1][i_mb_xy], &frames[b]->lowres_mvs[1][p1-b-1][i_mb_xy] };
<     int (*fenc_costs[2]) = { &frames[b]->lowres_mv_costs[0][b-p0-1][i_mb_xy], &frames[b]->lowres_mv_costs[1][p1-b-1][i_mb_xy] };
< 
<     DECLARE_ALIGNED_8( uint8_t pix1[2*17*FDEC_STRIDE] );
<     uint8_t *pix2 = pix1+17*FDEC_STRIDE;
<     DECLARE_ALIGNED_8(x264_me_t m[2]);
<     int i_bcost = COST_MAX;
<     int i_cost_bak;
<     int l, i;
< 
<     h->mb.pic.p_fenc[0] = h->mb.pic.fenc_buf;
<     // Load the lowres image data of a MB, as normal, size of an MB should be 16x16
<     h->mc.copy[PIXEL_16x16]( h->mb.pic.p_fenc[0], FENC_STRIDE, &fenc->filtered[0][i_pel_offset], i_stride, 16 );
< 
<     if( !p0 && !p1 && !b )
<         goto lowres_intra_mb;
< 
<     // Set the mv range before ME
<     h->mb.mv_min_fpel[0] = -16*h->mb.i_mb_x - 8;
<     h->mb.mv_max_fpel[0] = 16*( h->sps->i_mb_width - h->mb.i_mb_x - 1 ) + 8;
<     h->mb.mv_min_spel[0] = 16*( h->mb.mv_min_fpel[0] - 16 );
<     h->mb.mv_max_spel[0] = 16*( h->mb.mv_max_fpel[0] + 16 );
<     if( h->mb.i_mb_x >= h->sps->i_mb_width - 2 ) {
<         h->mb.mv_min_fpel[1] = (-8*h->mb.i_mb_y - 4)*2;
<         h->mb.mv_max_fpel[1] = (8*( h->sps->i_mb_height - h->mb.i_mb_y - 1 ) + 4)*2;
<         h->mb.mv_min_spel[1] = (4*( h->mb.mv_min_fpel[1] - 8 ))*2;
<         h->mb.mv_max_spel[1] = (4*( h->mb.mv_max_fpel[1] + 8 ))*2;
<     }
< 
< #define LOAD_HPELS_LUMA(dst, src) \
<     { \
<         (dst)[0] = &(src)[0][i_pel_offset]; \
<         (dst)[1] = &(src)[1][i_pel_offset]; \
<         (dst)[2] = &(src)[2][i_pel_offset]; \
<         (dst)[3] = &(src)[3][i_pel_offset]; \
<     }
< #define CLIP_MV( mv ) \
<     { \
<         mv[0] = x264_clip3( mv[0], h->mb.mv_min_spel[0], h->mb.mv_max_spel[0] ); \
<         mv[1] = x264_clip3( mv[1], h->mb.mv_min_spel[1], h->mb.mv_max_spel[1] ); \
<     }
<     // Compute the bidir cost of a MB when mv0 and mv1 already known
< #define TRY_BIDIR( mv0, mv1, penalty ) \
<     { \
<         int stride1 = FDEC_STRIDE, stride2 = FDEC_STRIDE; \
<         uint8_t *src1, *src2; \
<         int i_cost; \
<         src1 = h->mc.get_ref( pix1, &stride1, m[0].p_fref, m[0].i_stride[0], \
<                               (mv0)[0], (mv0)[1], 16, 16 ); \
<         src2 = h->mc.get_ref( pix2, &stride2, m[1].p_fref, m[1].i_stride[0], \
<                               (mv1)[0], (mv1)[1], 16, 16 ); \
<         h->mc.avg[PIXEL_16x16]( pix1, FDEC_STRIDE, src1, stride1, src2, stride2, i_bipred_weight ); \
<         i_cost = penalty + h->pixf.mbcmp[PIXEL_16x16]( \
<                            m[0].p_fenc[0], FENC_STRIDE, pix1, FDEC_STRIDE ); \
<         if( i_bcost > i_cost ) \
<             i_bcost = i_cost; \
<     }
< 
<     m[0].i_pixel = PIXEL_16x16;
<     m[0].p_cost_mv = a->p_cost_mv;
<     m[0].i_stride[0] = i_stride;
<     m[0].p_fenc[0] = h->mb.pic.p_fenc[0];
<     LOAD_HPELS_LUMA( m[0].p_fref, fref0->orgfiltered );
< 
<     /* Step 1: Calculate bi-cost of mv={0,0} and mv=mvr */
<     if( b_bidir )
<     {
<         int16_t *mvr = fref1->lowres_mvs[0][p1-p0-1][i_mb_xy];
<         int dmv[2][2];
<         int mv0[2] = {0,0};
< 
<         h->mc.memcpy_aligned( &m[1], &m[0], sizeof(x264_me_t) );
<         LOAD_HPELS_LUMA( m[1].p_fref, fref1->orgfiltered );
< 
<         dmv[0][0] = ( mvr[0] * dist_scale_factor + 128 ) >> 8;
<         dmv[0][1] = ( mvr[1] * dist_scale_factor + 128 ) >> 8;
<         dmv[1][0] = dmv[0][0] - mvr[0];
<         dmv[1][1] = dmv[0][1] - mvr[1];
<         CLIP_MV( dmv[0] );
<         CLIP_MV( dmv[1] );
< 
<         TRY_BIDIR( dmv[0], dmv[1], 0 );
<         if( dmv[0][0] | dmv[0][1] | dmv[1][0] | dmv[1][1] )
<            TRY_BIDIR( mv0, mv0, 0 );
<     }
< 
<     /* Step2: ME for ref0 and ref1 if needed */
<     i_cost_bak = i_bcost;
<     for( l = 0; l < 1 + b_bidir; l++ )
<     {
<         DECLARE_ALIGNED_4(int16_t mvc[4][2]) = {{0}};
<         int i_mvc = 0;
<         int16_t (*fenc_mv)[2] = fenc_mvs[l];
< 
<         if( do_search[l] ) {
<             // Step 2.1: Get the mvc and mvp from neighbouring MBs
<             /* Reverse-order MV prediction. because the function is reverse-scan-order called */
< #define MVC(mv) { *(uint32_t*)mvc[i_mvc] = *(uint32_t*)mv; i_mvc++; }
<             if( i_mb_x < h->sps->i_mb_width - 1 )
<                 MVC(fenc_mv[1]);                                // Right
<             if( i_mb_y < h->sps->i_mb_height - 1 ) {
<                 MVC(fenc_mv[i_mb_stride]);                // Bottom
<                 if( i_mb_x > 0 )
<                     MVC(fenc_mv[i_mb_stride-1]);        // Bottom-left
<                 if( i_mb_x < h->sps->i_mb_width - 1 )
<                     MVC(fenc_mv[i_mb_stride+1]);        // Bottom-right
<             }
< #undef MVC
<             x264_median_mv( m[l].mvp, mvc[0], mvc[1], mvc[2] );
<             
<             // Step 2.2: Perform ME
<             x264_me_search( h, &m[l], mvc, 3 );
< 
<             // Step 2.3: cost refinement
<             m[l].cost -= 2; // remove mvcost from skip mbs
<             if( *(uint32_t*)m[l].mv )
<                 m[l].cost += 5;
< 
<             // Step 2.4: Store the ME result(mv and cost) for future use
<             *(uint32_t*)fenc_mvs[l] = *(uint32_t*)m[l].mv;
<             *fenc_costs[l] = m[l].cost;
<         } else {
<             // If ME of fenc and refx have already done, just fetch the result
<             *(uint32_t*)m[l].mv = *(uint32_t*)fenc_mvs[l];
<             m[l].cost = *fenc_costs[l];
<         }
<         i_bcost = X264_MIN( i_bcost, m[l].cost );
<     }
<     
<     // Step 3: bidir refine after the actual mv have been known
<     if( b_bidir && ( *(uint32_t*)m[0].mv || *(uint32_t*)m[1].mv ) )
<         TRY_BIDIR( m[0].mv, m[1].mv, 5 );
<         
< lowres_intra_mb:
<     /* forbid intra-mbs in B-frames, because it's rare and not worth checking */
<     /* FIXME: Should we still forbid them now that we cache intra scores? */
<     if( !b_bidir )
<     {
<         int i_icost = COST_MAX, b_intra;
<         if( !fenc->b_intra_calculated ) {
<             uint8_t *pix = &pix1[16+FDEC_STRIDE-1];
<             uint8_t *src = &fenc->filtered[0][i_pel_offset - 1];
<             const int intra_penalty = 5;
<             int satds[4];
< 
<             memcpy( pix-FDEC_STRIDE, src-i_stride, 17 );
<             for( i=0; i<16; i++ )
<                 pix[i*FDEC_STRIDE] = src[i*i_stride];
<             pix++;
< 
<             for( i=0; i<7; i++ )
<             {
<                 int satd;
<                 h->predict_16x16[i]( pix );
<                 satd = h->pixf.mbcmp[PIXEL_16x16]( pix, FDEC_STRIDE, h->mb.pic.p_fenc[0], FENC_STRIDE );
<                 i_icost = X264_MIN( i_icost, satd );
<             }
< 
<             i_icost += intra_penalty;
<             fenc->i_intra_cost[i_mb_xy] = i_icost;
<         }
<         else
<             i_icost = fenc->i_intra_cost[i_mb_xy];
<             
<         b_intra = i_icost < i_bcost;//can b_intra be 0??
<         if( b_intra )
<             i_bcost = i_icost;
<         if(    i_mb_x > 0 && i_mb_x < h->sps->i_mb_width - 1
<             && i_mb_y > 0 && i_mb_y < h->sps->i_mb_height - 1 )
<         {
<             fenc->i_intra_mbs[b-p0] += b_intra;
<             fenc->i_cost_est[0][0] += i_icost;
<         }
<     }
< 
<     return i_bcost/4;
< }
< #undef TRY_BIDIR
< #else
450d249
< #endif